/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "taviarun.h"

TaviaRun::TaviaRun(const KURL &url, const KParts::URLArgs &args, TaviaHTMLView *html, KHTMLPart *part, QWidget *window, bool removeReferrer, bool trustedSource, bool hideErrorDialog)
 : KParts::BrowserRun(url,args,part,window,removeReferrer,trustedSource,hideErrorDialog)
{
    srcURL = url;
    srcURLArgs = args;
    htmlView = html;
    pPart = part;
}


TaviaRun::~TaviaRun()
{
}




/*!
    \fn TaviaRun::foundMimeType(const QString &_type)
 */
void TaviaRun::foundMimeType(const QString &_type)
{
    if (_type.lower().startsWith("image")) {
        htmlView->outputImage(srcURL,pPart);
        return;
    }
    if (_type == "text/html") {
        pPart->browserExtension()->setURLArgs(srcURLArgs);
        pPart->openURL(srcURL);
        //htmlView->browserExtension()->openURLRequest(srcURL,srcURLArgs);
        return;
    }
    //KRun::displayOpenWithDialog(srcURL,false);
    //KRun::runURL(srcURL,_type,false);
    //
    appRun();
    // ˡȥƥŪ˥
    //BrowserRun::foundMimeType(_type);
    // ˡȤץꥱꤻˤʤ
    KRun::displayOpenWithDialog(srcURL,false);
    /// @todo 󥯥åͤ
}


/*!
    \fn TaviaRun::slotRedirection(KIO::Job *job, const KURL& toURL)
 */
void TaviaRun::slotRedirection(KIO::Job *job, const KURL& toURL)
{
    // from KonqRun
    KURL fromURL = static_cast<KIO::TransferJob *>(job)->url();
    // m_argsϤ¤Ǥ⤷ʡ
    if (fromURL != toURL)
        m_args.setDoPost(false);
        srcURLArgs.setDoPost(false);
        srcURLArgs.setRedirectedRequest(true);
        m_args.setRedirectedRequest(true);
        srcURL = toURL;

}


/*!
    \fn TaviaRun::scanFile()
 */
void TaviaRun::scanFile()
{
    KParts::BrowserRun::scanFile();
    KIO::TransferJob *job = dynamic_cast<KIO::TransferJob*>(m_job);
    if (job && !job->error()) {
        connect(job,SIGNAL(redirection(KIO::Job *,const KURL&)),
            SLOT(slotRedirection(KIO::Job *,const KURL&)));
    }

}


/*!
    \fn TaviaRun::handleError (KIO::Job *job)
 */
void TaviaRun::handleError (KIO::Job *job)
{
    // BrowserRunϥե¸߳ǧQFileȤΤ
    // KIO::Job̵礢ꡣꤹȥեΤա
    if (job == 0) {
        htmlView->outputErrorMessage(srcURL,0,pPart);
        return;
    }
    if (job->error()) htmlView->outputErrorMessage(srcURL,job,pPart);
    else BrowserRun::handleError(job);
}
